// ROUTES FOR OUR API
// =============================================================================
var express = require('express');
var bcrypt = require('bcryptjs');
var router = express.Router(); // get an instance of the express Router
const querystring = require('querystring');
var mysql = require('./mysql');
// const _mysqlLabor = ["123.58.32.151", "pbl"]; //edu數據庫信息
// const _mysqluser = ["123.58.32.151", "cocorobouser"]; //用户数据库信息
const _mysqlLabor = ["172.16.12.5", "pbl"]; //edu數據庫信息
const _mysqluser = ["172.16.12.5", "cocorobouser"]; //edu數據庫信息
var crypto = require('crypto');
var https = require('https');

//統壹處理區域
router.use(async function(req, res, next) {
    await asynnext(req, res, next);
    //// make sure we go to the next routes and don't stop here
    //res.end("");
});

/**
 * @des 參數解釋同上
 */
function asynnext(req, res, next) {
    //異步處理
    return new Promise(async(resolve, reject) => {
        next();
        //resolve(true);aa
    });
}
/*測試*/
router.route('/a').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "a", json['ph'], json['pa']);
});
router.route('/b').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "b", json['ph'], json['pa']);
});
/* 注册接口 */
router.route('/register').post(function(req, res, next) {
    //mode的处理
    if (req.body[0]) {
        // 0 用户名 1 用户密码 2用户身份 3 第三方id（可有可无）
        p = Object.values(req.body[0]); //获取用户密码
        //没有第三方id的处理
        // if (p.length < 4) {
        //     p.push("")
        // }
        p[1] = bcrypt.hashSync(p[1], bcrypt.genSaltSync(10));
        //密码加密
        // bcrypt.hash(p[1], 10, function (err, hash) {
        //     if (err) {
        //         return next(err);
        //     }
        //     p[1] = hash;
        // });
        //参数拼接，注册
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "register");
        //返回注册用户数据
        // mysql.usselect(p, function (ret) {
        //     res.end(ret);
        // });
        mysql.usselect(p, function(ret) {
            res.end(JSON.stringify(ret));
        });
    }
});
/*登录接口*/
router.route('/login').all((req, res, next) => {
    //mode的处理
    if (req.body[0]) {
        // 0 用户名 1 用户密码
        c = Object.values(req.body[0]); //获取用户密码
        p = [c[0]]
            // p[1] = bcrypt.hashSync(p[1], bcrypt.genSaltSync(10));
        var _password = [c[0]];
        _password.unshift(_mysqlLabor[0], _mysqlLabor[1], "selectPassword");

        mysql.usselect(_password, function(ret) {
            var _ret = ret
            var paJ = _ret[0][0].userpassword
            bcrypt.compare(c[1], paJ, function(err, result) {
                // console.log(result)
                if (result) {
                    //参数拼接，登录
                    p.unshift(_mysqlLabor[0], _mysqlLabor[1], "selectLogin");
                    //执行存储过程
                    mysql.usselect(p, function(ret) {
                        res.end(JSON.stringify({ status: "1", ...ret }));
                    });
                } else {
                    res.end(JSON.stringify([{ status: "0" }]));
                }
            })
        });

        // console.log(isEqual)
    }

});

/*手机登录接口*/
router.route('/phoneLogin').all((req, res, next) => {
    //mode的处理
    if (req.body[0]) {
        // 0 用户名 1 用户密码
        c = Object.values(req.body[0]); //获取用户密码
        p = [c[0]]
            // p[1] = bcrypt.hashSync(p[1], bcrypt.genSaltSync(10));
        var _password = [c[0]];
        _password.unshift(_mysqluser[0], _mysqluser[1], "selectPassword");

        mysql.usselect(_password, function(ret) {
            if (ret[0].length) {
                var _ret = ret
                var paJ = _ret[0][0].password
                let uid = _ret[0][0].userid
                let duid = [uid]
                bcrypt.compare(c[1], paJ, function(err, result) {
                    // console.log(result)
                    if (result) {
                        //参数拼接，登录
                        duid.unshift(_mysqlLabor[0], _mysqlLabor[1], "selectUser");
                        //执行存储过程
                        mysql.usselect(duid, function(ret) {
                            res.end(JSON.stringify({ status: "1", ...ret }));
                        });
                    } else {
                        res.end(JSON.stringify([{ status: "0" }]));
                    }
                })
            } else {
                res.end(JSON.stringify([{ status: "0" }]));
            }
        });

        // console.log(isEqual)
    }

});

// 图片转base64
router.route('/imgToBase64').all((req, res, next) => {
    var json = queryString(req.url);
    //mode的处理
    https.get(json['img'], function(res2) {
        var chunks = [];
        var size = 0;
        res2.on('data', function(chunk) {
            chunks.push(chunk);
            size += chunk.length;　　 //累加缓冲数据的长度
        });
        res2.on('end', function(err) {
            var data = Buffer.concat(chunks, size);
            var base64Img = data.toString('base64');
            res.end(JSON.stringify([{ img: `data:image/png;base64,${base64Img}` }]));
        });
    });



});

/*登录接口*/
router.route('/loginRace').all((req, res, next) => {
    //mode的处理
    if (req.body[0]) {
        // 0 用户名 1 用户密码
        c = Object.values(req.body[0]); //获取用户密码
        p = [c[0]]
            // p[1] = bcrypt.hashSync(p[1], bcrypt.genSaltSync(10));
        var _password = [c[0]];
        _password.unshift(_mysqlLabor[0], _mysqlLabor[1], "selectPasswordRace");

        mysql.usselect(_password, function(ret) {
            var _ret = ret
            var paJ = _ret[0][0].password
            bcrypt.compare(c[1], paJ, function(err, result) {
                // console.log(result)
                if (result) {
                    //参数拼接，登录
                    p.unshift(_mysqlLabor[0], _mysqlLabor[1], "selectLoginRace");
                    //执行存储过程
                    mysql.usselect(p, function(ret) {
                        res.end(JSON.stringify({ status: "1", ...ret }));
                    });
                } else {
                    res.end(JSON.stringify([{ status: "0" }]));
                }
            })
        });

        // console.log(isEqual)
    }

});

/* 修改密码接口 */
router.route('/updatePassword').post(function(req, res, next) {
    //mode的处理
    if (req.body[0]) {
        let p = [req.body[0].userid];
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "getPassword"); //執行存儲過程
        mysql.usselect(p, function(ret) {
            var paJ = ret[0][0].password
            var op = bcrypt.hashSync(req.body[0].opassword, bcrypt.genSaltSync(10));
            bcrypt.compare(req.body[0].opassword, paJ, function(err, result) {
                // console.log(result)
                if (result) {
                    let p2 = [req.body[0].userid, bcrypt.hashSync(req.body[0].password, bcrypt.genSaltSync(10))];
                    p2.unshift(_mysqlLabor[0], _mysqlLabor[1], "updatePassword"); //執行存儲過程
                    mysql.usselect(p2, function(ret) {
                        res.end(JSON.stringify([{ success: 1 }]));
                    });
                } else {
                    res.end(JSON.stringify([{ success: 0 }]));
                }
            })

        });
    }
});

/* 赛事修改密码 */
router.route('/updatePassword1').post(function(req, res, next) {
    //mode的处理
    if (req.body[0]) {
        let p = [req.body[0].userid];
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "getPassword1"); //執行存儲過程
        mysql.usselect(p, function(ret) {
            var paJ = ret[0][0].password
            var op = bcrypt.hashSync(req.body[0].opassword, bcrypt.genSaltSync(10));
            bcrypt.compare(req.body[0].opassword, paJ, function(err, result) {
                // console.log(result)
                if (result) {
                    let p2 = [req.body[0].userid, bcrypt.hashSync(req.body[0].password, bcrypt.genSaltSync(10))];
                    p2.unshift(_mysqlLabor[0], _mysqlLabor[1], "updatePassword1"); //執行存儲過程
                    mysql.usselect(p2, function(ret) {
                        res.end(JSON.stringify([{ success: 1 }]));
                    });
                } else {
                    res.end(JSON.stringify([{ success: 0 }]));
                }
            })

        });
    }
});
/* 找寻重复手机号 */
router.route('/findPhone').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "findPhone", json['un']);
});
/* 找寻是否有此账号 */
router.route('/findUsername').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "findUsername", json['un']);
});
/* 找寻重复邮箱 */
router.route('/findMail').all((req, res, next) => {
    var json = queryString(req.url);
    usergetmysql(req, res, "findMail", json['un']);
});
/* 找寻重复学号 */
router.route('/findSid').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "findSid", json['un']);
});
/* 新增班级 */
router.route('/insertClass').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "insertClass", json['name'], json['oid'], json['uid']);
});
/* 修改班级 */
router.route('/updateClass').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "updateClass", json['id'], json['n'], json['oid']);
});
/* 查询班级 */
router.route('/selectClass').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectClass", json['cu'], json['oid'], json['cn'], json['page'], 10);
});
/* 删除班级 */
router.route('/deleteClass').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "deleteClass", json['id']);
});
/* 查询学校 */
router.route('/selectOrg').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectOrg");
});
/* 查询组织 */
router.route('/selectorg2').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectorg2");
});

/* 修改学校名称 */
router.route('/updateSN').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "updateSchoolName", json["oid"], json["n"]);
});
/* 教师端修改学校名称 */
router.route('/updateSchoolByOrg').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "updateSchoolByOrg", json["n"], json["d"], json["id"]);
});
/* 教师端查询未联结学校 */
router.route('/selectNoCSchool').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectNoCSchool");
});
/* 教师端新增或修改联结学校 */
router.route('/addNoSchool').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "addNoSchool", json["id"], json["coid"]);
});
/* 新增学生 */
router.route('/insertStudent').all((req, res, next) => {
    var json = queryString(req.url);
    json['userpassword'] = bcrypt.hashSync(json['userpassword'], bcrypt.genSaltSync(10))
    getmysql(req, res, "insertStudent", json['ph'], json['username'], json['userpassword'], json['type'], json['oid'], json['tid'], json['cid']);
});

// /* 新增学生 */
// router.route('/iStudent').all((req, res, next) => {
//     var json = queryString(req.url);
//     json['userpassword'] = bcrypt.hashSync(json['userpassword'], bcrypt.genSaltSync(10))
//     getmysql(req, res, "insertStudent", json['ph'], json['username'], json['userpassword'], json['type'], json['oid'], json['tid'], json['cid']);
// });

/* 查询学生 */
router.route('/selectStudent').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectStudent", json['oid'], json['cu'], json['cn'], json['page'], 10);
});

/* ppt根据学校查询学生 */
router.route('/selectStudentByScoolPPt').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectStudentByScoolPPt", json['oid'], json['cid']);
});

/* 查询学生 */
router.route('/selectStudentAdd').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectStudentAdd", json['oid'], json['cu'], json['cn']);
});
/* 查询老师 */
router.route('/selectTeacherAdd').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectTeacherAdd", json['oid'], json['cu'], json['cn']);
});
/* 查询老师 */
router.route('/selectTeacherAddOrg').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectTeacherAddOrg", json['oid'], json['cu'], json['cn']);
});
/* 查询学生 */
router.route('/selectStudentAddOrg').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectStudentAddOrg", json['oid'], json['cu'], json['cn']);
});
/* 查询全部用户 */
router.route('/selectUserAddOrg').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectUserAddOrg", json['oid'], json['cu'], json['cn']);
});
/* 查询全部用户 */
router.route('/selectUserAdd').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectUserAdd", json['oid'], json['cu'], json['cn']);
});
/* 查询全部用户 */
router.route('/selectUserByOidS').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectUserByOidS", json['oid'], json['org'], json['cu'], json['cn']);
});
/* 查询全部用户 */
router.route('/selectUserByOidS2').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectUserByOidS2", json['oid'], json['org'], json['cu'], json['cn'], json['page'], json['pageSize']);
});

/* 查询班级是否有重复 */
router.route('/selectC').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectC", json['className']);
});

/* 查询学校是否有重复 */
router.route('/selectS').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectS", json['schoolName']);
});

/* 修改个人信息 */
router.route('/updateUser').all((req, res, next) => {
    postmysql(req, res, "updateUser");
});

//查询老师的信息
router.route('/getUser').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectUserDeail", json['uid']);
});
//查询老师的信息
router.route('/getRaceUser').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "getRaceUser", json['uid']);
});
router.route('/selectUser').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectUser", json['userid']);
});
//查询教师端消息
router.route('/getNewsTeacher').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectNew", json['uid'], json['page'], 10);
});
//查询教师端消息
router.route('/selectNotice').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectNotice", json['uid'], json['oid'], json['org'], json['page'], 10);
});
//查询教师端消息
router.route('/selectNotice2').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectNotice2", json['uid'], json['oid'], json['org']);
});
//查询教师端消息
router.route('/addNotice').all((req, res, next) => {
    postmysql(req, res, "addNotice");
});
//查询教师端消息
router.route('/deleteNotice').all((req, res, next) => {
    postmysql(req, res, "deleteNotice");
});



//查询通知详情
router.route('/selectNewDetail').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectNewDetail", json['nid']);
});

//查出分组分类
router.route('/getGroup').all((req, res, next) => {
    getmysql(req, res, "selectGroupTeacher");
});

//查询这个老师底下的学生提交的作业
router.route('/getWorks').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectWorks", json['cn'], json['cid'], json['page'], 10);
});

//查询项目
router.route('/getProject').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectProject", json['type'], json['uid'], json['oid'], json['cn'], json['page'], 10);
});

//查询项目
router.route('/getMyProject').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectMyProject", json['uid'], json['page'], 10);
});

//查询项目成员
router.route('/selectProjectStudent').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_student", json['cn'], json['oid'], json['uid']);
});

//查询Banner列表
router.route('/selectBannerList').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectBannerList", json['page'], 10);
});
//查询Banner列表
router.route('/selectAllBanner').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectAllBanner", json["t"]);
});

//新增Banner
router.route('/insertBannerList').all((req, res, next) => {
    postmysql(req, res, "insertBannerList");
});
//删除提交的作业
router.route('/deleteCourseWork').all((req, res, next) => {
    postmysql(req, res, "deleteCourseWork");
});

//删除提交的作业
router.route('/deleteCourseWorkS').all((req, res, next) => {
    postmysql(req, res, "deleteCourseWorkS");
});

//删除Banner
router.route('/deleteBannerList').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "deleteBannerList", json['id']);
});


//新增课程
router.route('/addWork').all((req, res, next) => {
    postmysql(req, res, "insert_teacher_work");
});

//点赞评论
router.route('/insertComment').all((req, res, next) => {
    postmysql(req, res, "insertComment");
});
//点赞评论
router.route('/getComment').all((req, res, next) => {
    postmysql(req, res, "getComment");
});

//取消点赞
router.route('/deleteComment').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "deleteComment", json['wid'], json['lid']);
});

//上传批注图片
router.route('/updateCourseWorks').all((req, res, next) => {
    postmysql(req, res, "updateCourseWorks");
});
//上传文件
router.route('/addCourseWorks').all((req, res, next) => {
    postmysql(req, res, "addCourseWorks");
});
//上传文件
router.route('/addCourseWorksS').all((req, res, next) => {
    postmysql(req, res, "addCourseWorksS");
});
//可上传多个文件
router.route('/addCourseWorksR').all((req, res, next) => {
    postmysql(req, res, "addCourseWorksR");
});
//上传文件
router.route('/addCourseWorksTeacher').all((req, res, next) => {
    postmysql(req, res, "addCourseWorksTeacher");
});

//上传文件
router.route('/addCourseWorks2').all((req, res, next) => {
    var json = queryString(req.url);
    postmysql(req, res, "addCourseWorks", json['uid'], json['cid'], json['stage'], json['task'], json['tool'], json['content'], json['type']);
});
//上传文件
router.route('/addCourseWorks3').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "addCourseWorks2", json['uid'], json['cid'], json['stage'], json['task'], json['tool'], json['content'], json['type'], json['atool']);
});

//上传文件
router.route('/addCourseWorks4').all((req, res, next) => {
    postmysql3(req, res, "addCourseWorks3");
});
//上传文件
router.route('/addCourseWorks4s').all((req, res, next) => {
    postmysql3(req, res, "addCourseWorks4s");
});
//上传文件
router.route('/addCourseWorks5').all((req, res, next) => {
    postmysql(req, res, "addCourseWorks3");
});

//上传批量文件
router.route('/addCourseWorksPl').all((req, res, next) => {
    if (req.body[0]) {
        var p = Object.values(req.body[0]);
        let ateacher = p[0]
        let cid = p[1]
        let stage = p[2]
        let task = p[3]
        let tool = p[4]
        let files = JSON.parse(p[5])

        for (let i = 0; i < files.length; i++) {
            var k = [files[i].username, cid, stage, task, tool, files[i].url, files[i].fileType, ateacher, '50']

            k.unshift(_mysqlLabor[0], _mysqlLabor[1], 'addCourseWorksPl');
            //執行存儲過程
            mysql.usselect(k, function(ret) {
                if (i == files.length - 1) {
                    res.end(JSON.stringify(ret));
                }
            });
        }

    }
});

//修改课程权限（学生是否能查看所有作业）
router.route('/updateCourseSLook').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "updateCourseSLook", json['sopen'], json['cid']);
});
//修改阶段锁定状态
router.route('/updateCourseLookOpen').all((req, res, next) => {
    postmysql(req, res, "updateCourseLookOpen");
});
//查看阶段锁定的状态
router.route('/getCourseState').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "getCourseState", json['cid']);
});
//添加锁定状态
router.route('/addCourseState').all((req, res, next) => {
    postmysql(req, res, "addCourseState");
});
//修改锁定状态
router.route('/updateCourseSate').all((req, res, next) => {
    postmysql(req, res, "updateCourseSate");
});

//查询课程权限（学生是否能查看所有作业）
router.route('/selectCourseSLook').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectCourseSLook", json['cid']);
});

//查询作业详情
router.route('/selectWorksDetail2').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectWorksDetail2", json['uid'], json['cid'], json['stage'], json['task']);
});

//查询课程全部作业详情
router.route('/selectWorksDetail3').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectWorksDetail3", json['uid'], json['cid']);
});

//学习中心教师查询作业
router.route('/selectSWorks').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectSWorks", json['cid'], json['s'], json['t']);
});

//学习中心教师查询作业全部展示
router.route('/selectSWorks2').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectSWorks2", json['cid']);
});

//学习中心学生查询作业
router.route('/selectStudentWorks').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectStudentWorks", json['uid'], json['cid'], json['s'], json['t']);
});

//实时课堂作业评价
router.route('/updateStudentWork').all((req, res, next) => {
    postmysql(req, res, "updateStudentWork");
});

//学习中心查询学生
router.route('/selectWorksStudent').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectWorksStudent", json['oid'], json['cid']);
});

//批量上传查询学生
router.route('/selectSnameByCid').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectSnameByCid", json['cid']);
});

/* 查询学生 */
router.route('/selectStudent2').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectStudent2", json['oid'], json['cu'], json['cn'], json['cid'], json['page'], 10);
});
/* 查询教师 */
router.route('/selectTeacher').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectTeacher", json['org'], json['cu'], json['cn'], json['page'], 10);
});
/* 添加教师页面查询教师 */
router.route('/selectTcTeacher').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectTcTeacher", json['org'], json['oid'], json['cu'], json['cn'], json['page'], 10);
});
/* 查询所有评价体系 */
router.route('/selectAllEvaluation').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectAllEvaluation", json['oid']);
});
/* 根据市级用户查询评审员 */
router.route('/selectReviewer').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectReviewer", json['uid'], json['cn'], json['page'], 10);
});
/* 市级区县管理接口 */
router.route('/selectCReviewer').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectCReviewer", json['uid'], json['cn'], json['page'], 10);
});
/* 修改评审员 */
router.route('/updateReviewer').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "updateReviewer", json['n'], json['p'], json['t'], json['s'], json['uid']);
});
/* 删除评审员 */
router.route('/deleteReviewer').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "deleteReviewer", json['uid']);
});
/* 查询区县案例 */
router.route('/selecAnliBox').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selecAnliBox");
});
/* 查询市级案例 */
router.route('/selecAnliBox1').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selecAnliBox1");
});
/* 查询省级案例 */
router.route('/selecAnliBox2').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selecAnliBox2");
});
/* 查询通知公告 */
router.route('/selectRaceNotice').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectRaceNotice", json['page'], 10);
});
/* 查询通知公告详情 */
router.route('/getRaceNoticeDetail').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "getRaceNoticeDetail", json['nid']);
});

router.route('/addWorkNew').all((req, res, next) => {
    // postmysql(req, res, "insert_teacher_work_new");
    if (req.body[0]) {
        // p = Object.values(req.body[0]);
        p = [req.body[0].uid, req.body[0].title, req.body[0].brief, req.body[0].cover, req.body[0].astudent, req.body[0].see, req.body[0].chapters, req.body[0].template];
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "insert_teacher_work_new");
        //執行存儲過程
        mysql.usselect(p, function(ret) {
            let course = req.body[0].courseType;
            let courseId = ret[0][0].courseId;
            let userid = req.body[0].uid;
            delCourseType(course, courseId, userid);
            res.end(JSON.stringify({ ordernumber: ret[0][0].ordernumber, courseId: ret[0][0].courseId, success: 1 }));
            // res.end(JSON.stringify(ret)); 
        });
    }

});

router.route('/addWorkNew2').all((req, res, next) => {
    if (req.body[0]) {
        p = [req.body[0].uid, req.body[0].title, req.body[0].brief, req.body[0].cover, req.body[0].evaId, req.body[0].astudent, req.body[0].see, req.body[0].chapters, req.body[0].template, req.body[0].ateacher];
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "insert_teacher_work_new2"); //執行存儲過程
        mysql.usselect(p, function(ret) {
            let course = req.body[0].courseType;
            let courseId = ret[0][0].courseId;
            let userid = req.body[0].uid;
            delCourseType(course, courseId, userid);
            res.end(JSON.stringify({ ordernumber: ret[0][0].ordernumber, courseId: ret[0][0].courseId, success: 1 }));
        });
    }

});

router.route('/addCourseWorkNew2').all((req, res, next) => { //学生
    if (req.body[0]) {
        p = [req.body[0].uid, req.body[0].title, req.body[0].brief, req.body[0].cover, req.body[0].evaId, req.body[0].astudent, req.body[0].see, req.body[0].chapters, req.body[0].template, req.body[0].ateacher];
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "addCourseWorkNew2"); //執行存儲過程
        mysql.usselect(p, function(ret) {
            let course = req.body[0].courseType;
            let courseId = ret[0][0].courseId;
            let userid = req.body[0].uid;
            delCourseType(course, courseId, userid);
            res.end(JSON.stringify({ ordernumber: ret[0][0].ordernumber, courseId: ret[0][0].courseId, success: 1 }));
        });
    }

});

router.route('/addCourseWorkNew22').all((req, res, next) => { //学生
    if (req.body[0]) {
        p = [req.body[0].uid, req.body[0].title, req.body[0].brief, req.body[0].cover, req.body[0].evaId, req.body[0].astudent, req.body[0].see, req.body[0].chapters, req.body[0].template, req.body[0].ateacher];
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "addCourseWorkNew2"); //執行存儲過程
        mysql.usselect(p, function(ret) {
            let course = req.body[0].courseType;
            let courseId = ret[0][0].courseId;
            let userid = req.body[0].uid;
            delCourseTypeS(course, courseId, userid);
            res.end(JSON.stringify({ ordernumber: ret[0][0].ordernumber, courseId: ret[0][0].courseId, success: 1 }));
        });
    }
});


//新增赛事项目
router.route('/addRace').all((req, res, next) => {
    if (req.body[0]) {
        p = [req.body[0].uid, req.body[0].info, req.body[0].over, req.body[0].pro, req.body[0].act, req.body[0].exc, req.body[0].res];
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "addRace"); //執行存儲過程
        mysql.usselect(p, function(ret) {
            let course = req.body[0].courseType;
            let courseId = ret[0][0].id;
            let userid = req.body[0].uid;
            delCourseType1(course, courseId, userid);
            res.end(JSON.stringify({ courseId: courseId, success: 1 }));
        });
    }
});
//新增赛事账号信息
router.route('/addRaceUser').all((req, res, next) => {
    if (req.body[0]) {
        p = [req.body[0].reg, req.body[0].res, req.body[0].sch, req.body[0].n, req.body[0].p, req.body[0].t, req.body[0].parent];
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "addRaceUser"); //執行存儲過程
        mysql.usselect(p, function(ret) {
            let num = ret[0][0].num;
            let userid = ret[0][0].userid;
            if (num < 10) {
                num = "SZ" + "00" + num + "@gdae.com";
            } else if (num < 100) {
                num = "SZ" + "0" + num + "@gdae.com";
            } else if (num > 100) {
                num = "SZ" + num + "@gdae.com";
            }
            y = [userid, num, bcrypt.hashSync("123456", bcrypt.genSaltSync(10))];
            //参数拼接，注册
            y.unshift(_mysqlLabor[0], _mysqlLabor[1], "upRaceUserNamePassword");
            mysql.usselect(y, function(ret) {
                res.end(JSON.stringify(ret));
            });
            res.end(JSON.stringify({ num: num, success: 1 }));
        });
    }
});

//修改赛事项目
router.route('/updateRace').all((req, res, next) => {
    if (req.body[0]) {
        p = [req.body[0].id, req.body[0].info, req.body[0].over, req.body[0].pro, req.body[0].act, req.body[0].exc, req.body[0].res];
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "updateRace"); //執行存儲過程
        mysql.usselect(p, function(ret) {
            let course = req.body[0].courseType;
            let courseId = req.body[0].id;
            let userid = req.body[0].uid;
            delCourseType1(course, courseId, userid);
            res.end(JSON.stringify({ success: 1 }));
        });
    }
});

router.route('/addWorkNew3').all((req, res, next) => {
    if (req.body[0]) {
        p = [req.body[0].uid, req.body[0].title, req.body[0].brief, req.body[0].cover, req.body[0].astudent, req.body[0].see, req.body[0].chapters, req.body[0].template, req.body[0].ateacher];
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "insert_teacher_work_new3"); //執行存儲過程
        mysql.usselect(p, function(ret) {
            let course = req.body[0].courseType;
            let courseId = ret[0][0].courseId;
            let userid = req.body[0].uid;
            delCourseType(course, courseId, userid);
            res.end(JSON.stringify({ ordernumber: ret[0][0].ordernumber, courseId: ret[0][0].courseId, success: 1 }));
        });
    }

});


function delCourseType(course, courseId, userid) {
    let _courseId = courseId;
    var _userdata = [
        _courseId
    ];
    _userdata.unshift(_mysqlLabor[0], _mysqlLabor[1], "delete_courseType");
    mysql.usselect(_userdata, function(ret) {
        // console.log(ret);
        addCourseType(userid, course, _courseId)
    });

    // setTimeout(() => {
    // }, 1000);
}

function delCourseType1(course, courseId, userid) {
    let _courseId = courseId;
    var _userdata = [
        _courseId
    ];
    _userdata.unshift(_mysqlLabor[0], _mysqlLabor[1], "delete_courseType1");
    mysql.usselect(_userdata, function(ret) {
        // console.log(ret);
    });

    setTimeout(() => {
        addCourseType1(userid, course, _courseId)
    }, 1000);
}

function delCourseTypeS(course, courseId, userid) {
    let _courseId = courseId;
    var _userdata = [
        _courseId
    ];
    _userdata.unshift(_mysqlLabor[0], _mysqlLabor[1], "delete_courseTypeS");
    mysql.usselect(_userdata, function(ret) {
        // console.log(ret);
        addCourseTypeS(userid, course, _courseId)

    });

    // setTimeout(() => {
    // }, 1000);
}

function addCourseType(userid, course, _courseId) {
    var _uid = userid;
    var _courses = _courseId
    var _tid = JSON.parse(course)
    for (let i = 0; i < _tid.length; i++) {
        if (_tid[i] == '') {

            continue;

        }
        var _userdata = [
            _courses,
            _tid[i],
            _uid,
        ];
        _userdata.unshift(_mysqlLabor[0], _mysqlLabor[1], "add_courseType");
        mysql.usselect(_userdata, function(ret) {
            // console.log(ret);
        });
    }
}

function addCourseType1(userid, course, _courseId) {
    var _uid = userid;
    var _courses = _courseId
    var _tid = JSON.parse(course)
    for (let i = 0; i < _tid.length; i++) {
        if (_tid[i] == '') {

            continue;

        }
        var _userdata = [
            _courses,
            _tid[i],
            _uid,
        ];
        _userdata.unshift(_mysqlLabor[0], _mysqlLabor[1], "add_courseType1");
        mysql.usselect(_userdata, function(ret) {
            // console.log(ret);
        });
    }
}

function addCourseTypeS(userid, course, _courseId) {
    var _uid = userid;
    var _courses = _courseId
    var _tid = JSON.parse(course)
    for (let i = 0; i < _tid.length; i++) {
        if (_tid[i] == '') {

            continue;

        }
        var _userdata = [
            _courses,
            _tid[i],
            _uid,
        ];
        _userdata.unshift(_mysqlLabor[0], _mysqlLabor[1], "add_courseTypeS");
        mysql.usselect(_userdata, function(ret) {
            // console.log(ret);
        });
    }
}

//修改课程
// router.route('/updateWork').all((req, res, next) => {
//     postmysql(req, res, "update_teacher_work");
// });

router.route('/updateWorkNew').all((req, res, next) => {
    if (req.body[0]) {
        // p = Object.values(req.body[0]);
        p = [req.body[0].cid, req.body[0].title, req.body[0].brief, req.body[0].cover, req.body[0].astudent, req.body[0].see, req.body[0].chapters, req.body[0].template];
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "update_teacher_work_new");
        //執行存儲過程
        mysql.usselect(p, function(ret) {
            let course = req.body[0].courseType;
            let courseId = req.body[0].cid;
            let userid = req.body[0].uid;
            delCourseType(course, courseId, userid);
            res.end(JSON.stringify({ success: 1 }));
            // res.end(JSON.stringify(ret)); 
        });
    }
});

//查询课程
// router.route('/selectCourse').all((req, res, next) => {
//     var json = queryString(req.url);
//     getmysql(req, res, "select_course", json['type'], json['uid'], json['oid'], json['page'], 10);
// });

router.route('/updateWorkNew2').all((req, res, next) => {
    // if (req.body[0]) {
    //     p = [req.body[0].cid, req.body[0].title, req.body[0].brief, req.body[0].cover,req.body[0].evaId, req.body[0].astudent, req.body[0].see, req.body[0].chapters, req.body[0].template];
    //     p.unshift(_mysqlLabor[0], _mysqlLabor[1], "update_teacher_work_new2"); //執行存儲過程
    //     mysql.usselect(p, function(ret) {
    //         let course = req.body[0].courseType;
    //         let courseId = req.body[0].cid;
    //         let userid = req.body[0].uid;
    //         delCourseType(course, courseId, userid);
    //         res.end(JSON.stringify({ success: 1 }));
    //     });
    // }
    if (req.body[0]) {
        p = [req.body[0].cid, req.body[0].title, req.body[0].brief, req.body[0].cover, req.body[0].evaId, req.body[0].astudent, req.body[0].see, req.body[0].chapters, req.body[0].template, req.body[0].ateacher];
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "update_teacher_work_new2"); //執行存儲過程
        mysql.usselect(p, function(ret) {
            let course = req.body[0].courseType;
            let courseId = req.body[0].cid;
            let userid = req.body[0].uid;
            delCourseType(course, courseId, userid);
            res.end(JSON.stringify({ success: 1 }));
        });
    }
});

router.route('/updateStudentWorkNew2').all((req, res, next) => { //学生
    if (req.body[0]) {
        p = [req.body[0].cid, req.body[0].title, req.body[0].brief, req.body[0].cover, req.body[0].evaId, req.body[0].astudent, req.body[0].see, req.body[0].chapters, req.body[0].template, req.body[0].ateacher];
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "updateStudentWorkNew2"); //執行存儲過程
        mysql.usselect(p, function(ret) {
            let course = req.body[0].courseType;
            let courseId = req.body[0].cid;
            let userid = req.body[0].uid;
            delCourseType(course, courseId, userid);
            res.end(JSON.stringify({ success: 1 }));
        });
    }
});

router.route('/updateStudentWorkNew22').all((req, res, next) => { //学生
    if (req.body[0]) {
        p = [req.body[0].cid, req.body[0].title, req.body[0].brief, req.body[0].cover, req.body[0].evaId, req.body[0].astudent, req.body[0].see, req.body[0].chapters, req.body[0].template, req.body[0].ateacher];
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "updateStudentWorkNew2"); //執行存儲過程
        mysql.usselect(p, function(ret) {
            let course = req.body[0].courseType;
            let courseId = req.body[0].cid;
            let userid = req.body[0].uid;
            delCourseTypeS(course, courseId, userid);
            res.end(JSON.stringify({ success: 1 }));
        });
    }
});

router.route('/updateWorkNew3').all((req, res, next) => {
    if (req.body[0]) {
        p = [req.body[0].cid, req.body[0].title, req.body[0].brief, req.body[0].cover, req.body[0].astudent, req.body[0].see, req.body[0].chapters, req.body[0].template, req.body[0].ateacher];
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "update_teacher_work_new3"); //執行存儲過程
        mysql.usselect(p, function(ret) {
            let course = req.body[0].courseType;
            let courseId = req.body[0].cid;
            let userid = req.body[0].uid;
            delCourseType(course, courseId, userid);
            res.end(JSON.stringify({ success: 1 }));
        });
    }
});

function guid() {
    var _num,
        i,
        _guid = "";
    for (i = 0; i < 32; i++) {
        _guid += Math.floor(Math.random() * 16).toString(16); //随机0  - 16 的数字 转变为16进制的字符串
        _num = Math.floor((i - 7) / 4); //计算 (i-7)除4
        if (_num > -1 && _num < 4 && i == 7 + 4 * _num) {
            //会使guid中间加 "-"   形式为xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx
            _guid += "-";
        }
    }
    return _guid;
}

router.route('/updateWorkNew4').all((req, res, next) => {
    if (req.body[0]) {
        let p = [req.body[0].cid];
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "select_course_detail"); //執行存儲過程
        mysql.usselect(p, function(ret) {
            let _unitIndex = parseInt(req.body[0].unitIndex);
            let _chapters = JSON.parse(req.body[0].chapters);
            let _unitJson = JSON.parse(ret[0][0].chapters)
            if ((_unitJson.length - 1) < _unitIndex) {
                let _i = _unitIndex - (_unitJson.length - 1)
                for (let i = 0; i < _i; i++) {
                    _unitJson.push({
                        dyName: "", //单元标题
                        chapterInfo: [{
                            isread: false,
                            chapterid: guid(),
                            title: "",
                            courseName: "",
                            taskJson: [{
                                task: "",
                                taskDetail: "",
                                chapterData: [],
                                toolText: "",
                                toolChoose: [{
                                    tool: [],
                                    toolDetail: "",
                                    toolType: 0,
                                    askCount: 1,
                                    askTitle: "",
                                    askJson: [{ askstitle: "", askItem: 1, checkList: [] }],
                                }, ],
                                isShowTools: false,
                                askCount: 1,
                                isFold: 0,
                                askTitle: "",
                                askJson: [{ askstitle: "", askItem: 1, checkList: [] }],
                                checkJson: [{ checkCount: [], checkPerent: [] }],
                                homeworkList: [],
                            }, ],
                            itemCount: 1,
                            fileList1: [],
                            video: [],
                            testData: [],
                            pData: [],
                            templateArray: [],
                        }, ],
                    })
                }
                _unitJson[_unitIndex] = _chapters[_unitIndex]
            } else {
                _unitJson[_unitIndex] = _chapters[_unitIndex]
            }
            // console.log(_unitJson);
            let p2 = [req.body[0].cid, JSON.stringify(_unitJson).replaceAll(/%/g, "%25")];
            p2.unshift(_mysqlLabor[0], _mysqlLabor[1], "update_teacher_work_new4"); //執行存儲過程
            mysql.usselect(p2, function(ret) {
                res.end(JSON.stringify({ success: 1 }));
            });
            // res.end(JSON.stringify({ success: 1 }));
        });
    }
});

router.route('/updateStudentWorkNew4').all((req, res, next) => { //学生
    if (req.body[0]) {
        let p = [req.body[0].cid];
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "select_student_course_detail2"); //執行存儲過程
        mysql.usselect(p, function(ret) {
            let _unitIndex = parseInt(req.body[0].unitIndex);
            let _chapters = JSON.parse(req.body[0].chapters);
            let _unitJson = JSON.parse(ret[0][0].chapters)
            if ((_unitJson.length - 1) < _unitIndex) {
                let _i = _unitIndex - (_unitJson.length - 1)
                for (let i = 0; i < _i; i++) {
                    _unitJson.push({
                        dyName: "", //单元标题
                        chapterInfo: [{
                            isread: false,
                            chapterid: guid(),
                            title: "",
                            courseName: "",
                            taskJson: [{
                                task: "",
                                taskDetail: "",
                                chapterData: [],
                                toolText: "",
                                toolChoose: [{
                                    tool: [],
                                    toolDetail: "",
                                    toolType: 0,
                                    askCount: 1,
                                    askTitle: "",
                                    askJson: [{ askstitle: "", askItem: 1, checkList: [] }],
                                }, ],
                                isShowTools: false,
                                askCount: 1,
                                isFold: 0,
                                askTitle: "",
                                askJson: [{ askstitle: "", askItem: 1, checkList: [] }],
                                checkJson: [{ checkCount: [], checkPerent: [] }],
                                homeworkList: [],
                            }, ],
                            itemCount: 1,
                            fileList1: [],
                            video: [],
                            testData: [],
                            pData: [],
                            templateArray: [],
                        }, ],
                    })
                }
                _unitJson[_unitIndex] = _chapters[_unitIndex]
            } else {
                _unitJson[_unitIndex] = _chapters[_unitIndex]
            }
            // console.log(_unitJson);
            let p2 = [req.body[0].cid, JSON.stringify(_unitJson).replaceAll(/%/g, "%25")];
            p2.unshift(_mysqlLabor[0], _mysqlLabor[1], "updateStudentWorkNew4"); //執行存儲過程
            mysql.usselect(p2, function(ret) {
                res.end(JSON.stringify({ success: 1 }));
            });
            // res.end(JSON.stringify({ success: 1 }));
        });
    }
});

//协同删除阶段
router.route('/deleteWork').all((req, res, next) => {
    if (req.body[0]) {
        let p = [req.body[0].cid];
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "select_course_detail"); //執行存儲過程
        mysql.usselect(p, function(ret) {
            let _chapid = req.body[0].chapid;
            // console.log(_chapid);
            let _chapters = JSON.parse(req.body[0].chapters);
            let _unitJson = JSON.parse(ret[0][0].chapters)
            let _unitJson2 = []
            for (var i = 0; i < _unitJson.length; i++) {
                if (_unitJson[i].chapterInfo[0].chapterid != _chapid) {
                    // console.log(1);
                    // _unitJson.splice(i, -1)
                    _unitJson2.push(_unitJson[i])
                        // break;
                }
            }
            // console.log(_unitJson2);
            let p2 = [req.body[0].cid, JSON.stringify(_unitJson2).replaceAll(/%/g, "%25")];
            p2.unshift(_mysqlLabor[0], _mysqlLabor[1], "update_teacher_work_new4"); //執行存儲過程
            mysql.usselect(p2, function(ret) {
                res.end(JSON.stringify({ success: 1 }));
            });
            // res.end(JSON.stringify({ success: 1 }));
        });
    }
});

//协同删除阶段
router.route('/deleteStudentWork').all((req, res, next) => { //学生
    if (req.body[0]) {
        let p = [req.body[0].cid];
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "select_student_course_detail2"); //執行存儲過程
        mysql.usselect(p, function(ret) {
            let _chapid = req.body[0].chapid;
            // console.log(_chapid);
            let _chapters = JSON.parse(req.body[0].chapters);
            let _unitJson = JSON.parse(ret[0][0].chapters)
            let _unitJson2 = []
            for (var i = 0; i < _unitJson.length; i++) {
                if (_unitJson[i].chapterInfo[0].chapterid != _chapid) {
                    // console.log(1);
                    // _unitJson.splice(i, -1)
                    _unitJson2.push(_unitJson[i])
                        // break;
                }
            }
            // console.log(_unitJson2);
            let p2 = [req.body[0].cid, JSON.stringify(_unitJson2).replaceAll(/%/g, "%25")];
            p2.unshift(_mysqlLabor[0], _mysqlLabor[1], "updateStudentWorkNew4"); //執行存儲過程
            mysql.usselect(p2, function(ret) {
                res.end(JSON.stringify({ success: 1 }));
            });
            // res.end(JSON.stringify({ success: 1 }));
        });
    }
});

//协同恢复删除的阶段
router.route('/restoreWork').all((req, res, next) => {
    if (req.body[0]) {
        let p = [req.body[0].cid];
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "select_course_detail"); //執行存儲過程
        mysql.usselect(p, function(ret) {
            let _chapid = req.body[0].chapid;
            // console.log(_chapid);
            let _chapters = JSON.parse(req.body[0].chapters);
            let _unitJson = JSON.parse(ret[0][0].chapters)
            let _unitJson2 = []
            let chpaindex;
            for (var i = 0; i < _chapters.length; i++) {
                if (_chapters[i].chapterInfo[0].chapterid == _chapid) {
                    chpaindex = i
                }
            }
            for (var i = 0; i < _unitJson.length; i++) {
                if (_unitJson[i].chapterInfo[0].chapterid != _chapid) {
                    // console.log(1);
                    // _unitJson.splice(i, -1)
                    _unitJson2.push(_unitJson[i])
                        // break;
                }
            }
            _unitJson2.splice(chpaindex, 0, _chapters[chpaindex])
                // console.log(_unitJson2);
            let p2 = [req.body[0].cid, JSON.stringify(_unitJson2).replaceAll(/%/g, "%25")];
            p2.unshift(_mysqlLabor[0], _mysqlLabor[1], "update_teacher_work_new4"); //執行存儲過程
            mysql.usselect(p2, function(ret) {
                res.end(JSON.stringify({ success: 1 }));
            });
            // res.end(JSON.stringify({ success: 1 }));
        });
    }
});

//协同恢复删除的阶段
router.route('/restoreStudentWork').all((req, res, next) => { //学生
    if (req.body[0]) {
        let p = [req.body[0].cid];
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "select_student_course_detail2"); //執行存儲過程
        mysql.usselect(p, function(ret) {
            let _chapid = req.body[0].chapid;
            // console.log(_chapid);
            let _chapters = JSON.parse(req.body[0].chapters);
            let _unitJson = JSON.parse(ret[0][0].chapters)
            let _unitJson2 = []
            let chpaindex;
            for (var i = 0; i < _chapters.length; i++) {
                if (_chapters[i].chapterInfo[0].chapterid == _chapid) {
                    chpaindex = i
                }
            }
            for (var i = 0; i < _unitJson.length; i++) {
                if (_unitJson[i].chapterInfo[0].chapterid != _chapid) {
                    // console.log(1);
                    // _unitJson.splice(i, -1)
                    _unitJson2.push(_unitJson[i])
                        // break;
                }
            }
            _unitJson2.splice(chpaindex, 0, _chapters[chpaindex])
                // console.log(_unitJson2);
            let p2 = [req.body[0].cid, JSON.stringify(_unitJson2).replaceAll(/%/g, "%25")];
            p2.unshift(_mysqlLabor[0], _mysqlLabor[1], "updateStudentWorkNew4"); //執行存儲過程
            mysql.usselect(p2, function(ret) {
                res.end(JSON.stringify({ success: 1 }));
            });
            // res.end(JSON.stringify({ success: 1 }));
        });
    }
});

router.route('/selectCourseNew').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_course_new", json['type'], json['uid'], json['oid'], json['typea'], json['typeb'], json['typec'], json['typed'], json['typeE'], json['cu'], json['cn'], json['page'], 10);
});
router.route('/selectCourseNew2').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_course_new2", json['type'], json['uid'], json['oid'], json['org'], json['typea'], json['typeb'], json['typec'], json['typed'], json['typeE'], json['cu'], json['cn'], json['page'], json['pageSize']);
});
router.route('/selectStudentCourseNew2').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectStudentCourseNew2", json['type'], json['uid'], json['oid'], json['org'], json['typea'], json['typeb'], json['typec'], json['typed'], json['typeE'], json['cu'], json['cn'], json['page'], 10);
});
router.route('/selectStudentCourseNew22').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectStudentCourseNew22", json['type'], json['uid'], json['oid'], json['org'], json['typea'], json['typeb'], json['typec'], json['typed'], json['typef'], json['typeE'], json['cu'], json['cn'], json['page'], json['pageSize']);
});
router.route('/selectStudentCourseNew222').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectStudentCourseNew222", json['type'], json['uid'], json['oid'], json['org'], json['typea'], json['typeb'], json['typec'], json['typed'], json['typef'], json['typeE'], json['cu'], json['cn'], json['page'], json['pageSize']);
});
router.route('/selectStudentCourseNew22Mode').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectStudentCourseNew22Mode", json['type'], json['uid'], json['oid'], json['org'], json['typea'], json['typeb'], json['typec'], json['typed'], json['typef'], json['typeE'], json['cu'], json['cn']);
});

//查询协同编辑课程
router.route('/selectCourseTeam').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectCourseTeam", json['uid'], json['oid']);
});


//查询学校
router.route('/selectSchoolName').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectOidName", json['cu'], json['cn'], json['page'], 10);
});
//查询组织
router.route('/selectOrgName').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectOrgName", json['page'], 10);
});

//查询学校
router.route('/selectSchoolName2').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectOidName2", json['oid']);
});

//查询学校
router.route('/selectSchoolNameOrg').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectSchoolNameOrg", json['org'], json['page'], 10);
});

//查询协同学校和被协同学校
router.route('/selectOrgType').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectOrgType", json['t'], json['org'], json['page'], 10);
});

//新增批注
router.route('/addPz').all((req, res, next) => {
    postmysql(req, res, "addPz");
});
//新增批注
router.route('/addPz2').all((req, res, next) => {
    postmysql(req, res, "addPz2");
});
//删除批注
router.route('/deletePz').all((req, res, next) => {
    postmysql(req, res, "deletePz");
});
//查询批注列表
router.route('/selectPzList').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectPzList", json['cid'], json['s'], json['t']);
});
//评分
router.route('/scoreWork').all((req, res, next) => {
    postmysql(req, res, "scoreWork");
});
//删除学生
router.route('/deleteStudent').all((req, res, next) => {
    postmysql(req, res, "delete_student");
});
//查询学校底下的班级
router.route('/selectClassBySchool').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectClassBySchool", json['oid']);
});
//查询学校底下的班级
router.route('/selectClassBySchoolSearch').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectClassBySchoolSearch", json['oid'], json['cn']);
});
//查询组织底下的学校
router.route('/selectSchoolByOrg').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectSchoolByOrg", json['org']);
});
//学生注册接口
router.route('/register_student').post(function(req, res, next) {
    //mode的处理
    if (req.body[0]) {
        // 0 用户名 1 用户密码 2用户身份 3 第三方id（可有可无）
        p = Object.values(req.body[0]); //获取用户密码
        //没有第三方id的处理
        // if (p.length < 4) {
        //     p.push("")
        // }
        p[1] = bcrypt.hashSync(p[1], bcrypt.genSaltSync(10));
        //密码加密
        // bcrypt.hash(p[1], 10, function (err, hash) {
        //     if (err) {
        //         return next(err);
        //     }
        //     p[1] = hash;
        // });
        //参数拼接，注册
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "register_student");
        //返回注册用户数据
        // mysql.usselect(p, function (ret) {
        //     res.end(ret);
        // });
        mysql.usselect(p, function(ret) {
            res.end(JSON.stringify(ret));
        });
    }
});
//查询课程详情
router.route('/selectCourseDetail').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectCourseDetail", json['courseId']);
});
//查询课程详情
router.route('/selectCourseDetail2').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectCourseDetail2", json['courseId']);
});
//查询学校底下的所有赛事
router.route('/selectRaceByOid').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectRaceByOid", json['sid']);
});
//修改作业学生名称
router.route('/updateCourseWorksName').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "updateCourseWorksName", json['n'], json['cid']);
});
//查询课程详情
router.route('/selectStudentCourseDetail').all((req, res, next) => { //学生
    var json = queryString(req.url);
    getmysql(req, res, "selectStudentCourseDetail", json['courseId']);
});
//查询课程详情
router.route('/selectStudentCourseDetail2').all((req, res, next) => { //学生
    var json = queryString(req.url);
    getmysql(req, res, "selectStudentCourseDetail2", json['courseId']);
});
//跳转阶段时，如果有课程就查询1返回，如果没有就插入
router.route('/addUserR').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "insertUserR", json['uid'], json['cid']);
});
//新增学生端作业
router.route('/addWorks').all((req, res, next) => {
    postmysql(req, res, "add_works");
});
//查询已提交作业
router.route('/selectWork').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectWork", json['cid'], json['stage'], json['task'], json['uid']);
});
//查询作业详情
router.route('/selectWorksDetail').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectWorksDetail", json['uid'], json['cid']);
});
//新增作业评分
router.route('/updateWorks').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "updateWorks", json['rate'], json['tuid'], json['id']);
});
//新增素材信息
router.route('/addMtl').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "add_mtl", json['cInfo'], json['t'], json['cBy']);
});

//根据类型查询素材信息
router.route('/selectMtl').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectMtl", json['t'], json['page'], 10);
});
//根据类型查询素材信息
router.route('/selectMtl2').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectMtl2", json['t'], json['uid'], json['page'], 10);
});
//学习中心
//新增学习资源信息
router.route('/addStuMtl').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "addStuMtl", json['cInfo'], json['t'], json['cBy']);
});
//根据类型查询学习资料信息
router.route('/selectStuMtl').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectStuMtl", json['t'], json['page'], 10);
});
//删除素材
router.route('/deleteStuM').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "deleteStuM", json['id']);
});


//查询学生信息
router.route('/selectSDetail').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectStudentDetail", json['uid']);
});
//查询个人课程
router.route('/selectMyCourse').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectMyCourse", json['uid']);
});
//查询个人课程groupby课程id
router.route('/selectMyCourseBycid').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectMyCourseBycid", json['uid']);
});
//查询所有课程
router.route('/selectAllCourse').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectAllCourse", json['oid'], json['page'], 10);
});
//根据班级查询所有课程
router.route('/selectAllCourseByCid').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectAllCourseByCid", json['oid'], json['cid'], json['page'], 10);
});
//根据分类查询所有课程
router.route('/selectTypeCourse').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectTypeCourse", json['uid'], json['oid'], json['typea'], json['typeb'], json['typec'], json['typed'], json['typeE'], json['cu'], json['cn'], json['classid'], json['page'], 10);
});
//根据分类查询所有课程
router.route('/selectTypeCourse2').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectTypeCourse2", json['uid'], json['oid'], json['typea'], json['typeb'], json['typec'], json['typed'], json['typeE'], json['cu'], json['cn'], json['classid'], json['org'], json['page'], 10);
});
//根据分类查询所有课程
router.route('/selectTypeCourse2Mode').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectTypeCourse2Mode", json['uid'], json['oid'], json['typea'], json['typeb'], json['typec'], json['typed'], json['typeE'], json['cu'], json['cn'], json['classid'], json['org']);
});
//根据分类查询所有课程
router.route('/selectTypeCourse2GM').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectTypeCourse2GM", json['uid'], json['oid'], json['typea'], json['typeb'], json['typec'], json['typed'], json['typeE'], json['cu'], json['cn'], json['classid'], json['org'], json['page'], 10);
});
//根据分类查询所有课程
router.route('/selectCourseExamine').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectCourseExamine", json['oid'], json['org'], json['cn'], json['page'], 10);
});
//根据分类查询所有课程
router.route('/selectTypeCourse3').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectTypeCourse3", json['uid'], json['oid'], json['typea'], json['typeb'], json['typec'], json['typed'], json['typeE'], json['cu'], json['cn'], json['classid'], json['org'], json['page'], 10);
});
//审核课程
router.route('/examineCourse').all((req, res, next) => {
    postmysql(req, res, "examineCourse");
});

//删除素材
router.route('/deleteM').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "deleteM", json['id']);
});
//点击阶段时添加观看人数
router.route('/updateVc').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "updateVc", json['cid']);
});
//删除课程
router.route('/deleteCourse').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "deleteCourse", json['cid']);
});
//删除课程
router.route('/deleteStudentCourse').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "deleteStudentCourse", json['cid']);
});
//复制课程
router.route('/copyCourse').all((req, res, next) => {
    postmysql(req, res, "copyCourse");
});
//查看课程
router.route('/select_course_detail').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_course_detail", json['cid']);
});

//查看课程
router.route('/select_student_course_detail').all((req, res, next) => { //学生
    var json = queryString(req.url);
    getmysql(req, res, "select_student_course_detail", json['cid']);
});
//查看课程
router.route('/select_student_course_detail2').all((req, res, next) => { //学生
    var json = queryString(req.url);
    getmysql(req, res, "select_student_course_detail2", json['cid']);
});
//查看课程
router.route('/getExportScourse').all((req, res, next) => { //学生
    var json = queryString(req.url);
    getmysql(req, res, "getExportScourse", json['cid']);
});
//模糊查找课程
// router.route('/searchCourse').all((req, res, next) => {
//     var json = queryString(req.url);
//     getmysql(req, res, "searchCourse", json['cu'], json['cn'], json['page'], 10);
// });
//创建调查问卷
router.route('/addAsk').all((req, res, next) => {
    postmysql(req, res, "insert_ask");
});
//学生提交问卷
router.route('/addAskList').all((req, res, next) => {
    postmysql(req, res, "insert_askList");
});
//根据课程id阶段id获取已提交的问卷
router.route('/getAskListByCidStage').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "getAskListByCidStage", json['cid'], json['stage'], json['task']);
});
//获取调查问卷
router.route('/getAsk').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_ask", json['uid'], json['page'], 10);
});
//删除问卷
router.route('/deleteAsk').all((req, res, next) => {
    postmysql(req, res, "deleteAsk");
});
//问卷调查数据统计
router.route('/getAskListByAskid').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_askListByAskid", json['aid']);
});
//删除学生提交问卷
router.route('/deleteAskList').all((req, res, next) => {
    postmysql(req, res, "update_askList_delete");
});
//根据id获取调查问卷
router.route('/getAskList').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_askList", json['uid'], json['page'], 10);
});
//查看便签列表
router.route('/selectNote').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectNote", json['uid']);
});
//新增便签列表
router.route('/insertNote').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "insertNote", json['uid'], json['c']);
});
//根据便签id修改便签内容
router.route('/updateNote').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "updateNote", json['nid'], json['c']);
});
//删除便签
router.route('/deleteNote').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "deleteNote", json['nid']);
});
//查询便签
router.route('/selectNoteContent').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectNoteContent", json['cn']);
});
//修改用户信息
router.route('/updateUserByEdu').all((req, res, next) => {
    postmysql(req, res, "updateUserByEdu");
});
//修改用户信息
router.route('/updateUserByEdu1').all((req, res, next) => {
    postmysql(req, res, "updateUserByEdu1");
});
//修改用户信息
router.route('/updateUserByEduOid').all((req, res, next) => {
    postmysql(req, res, "updateUserByEduOid");
});
//修改学生信息
router.route('/updateStudentInfo').all((req, res, next) => {
    postmysql(req, res, "updateStudentInfo");
});
//教师端data修改pbl用户信息
router.route('/updatePblMessage').all((req, res, next) => {
    postmysql2(req, res, "updatePblMessage");
});
//教师端data修改pbl用户信息
router.route('/addLoginOperation').all((req, res, next) => {
    postmysql2(req, res, "addLoginOperation");
});
router.route('/updatePblMessage2').all((req, res, next) => {
    postmysql(req, res, "updatePblMessage");
});
router.route('/updateRaceUser').all((req, res, next) => {
    postmysql(req, res, "updateRaceUser");
});
//查询用户信息
router.route('/selectUser').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectUser", json['userid']);
});
//查询分类及所有子分类
router.route('/selectAllType').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectAllType", json['org'], json['oid']);
});
//查询分类及所有子分类
router.route('/selectAllTypeS').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectAllTypeS", json['org'], json['oid']);
});
//查询分类及子分类
router.route('/selectType').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectType", );
});
//查询分类及子分类
router.route('/selectStudentType').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectStudentType", );
});
//查询赛事分类及子分类
router.route('/selectMatType').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectMatType", );
});

//根据学校查询分类
router.route('/selectPtype').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectPtype", json["page"], 10);
});
//根据学校查询学生项目分类
router.route('/selectSPtype').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectSPtype", json["page"], 10);
});
//根据学校查询分类1
router.route('/selectPtype1').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectPtype1", json["oid"], json["page"], 10);
});
//添加分类
router.route('/addPtype').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "addPtype", json["n"], json["uid"], json["oid"]);
});
//修改分类
router.route('/updatePtype').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "updatePtype", json["n"], json["tid"]);
});
//修改学生项目分类
router.route('/updateSPtype').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "updateSPtype", json["n"], json["tid"]);
});
//删除分类
router.route('/deletePtype').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "deletePtype", json["tid"]);
});
//删除学生项目分类
router.route('/deleteSPtype').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "deleteSPtype", json["tid"]);
});
//查询子分类列表
router.route('/selectStype').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectStype", json["pid"], json["oid"], json["page"], 10);
});
//查询学生项目子分类列表
router.route('/selectSStype').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectSStype", json["pid"], json["oid"], json["page"], 10);
});
//添加子分类
router.route('/addStype').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "addStype", json["pid"], json["n"], json["uid"], json["oid"]);
});
//添加学生项目子分类
router.route('/addSStype').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "addSStype", json["pid"], json["n"], json["uid"], json["oid"]);
});

//查看本校所有学生（分页）
router.route('/selectAllStudent').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectAllStudent", json["oid"], json["cn"], json["cid"], json["page"], 10);
});

//根据学校id查询子分类
router.route('/selectTypeByOid').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectTypeByOid", json["oid"]);
});

//根据学校id查询子分类
router.route('/selectTypeByOrg').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectTypeByOid", json["oid"]);
});

//根据组织id查询子分类
router.route('/selectStudentTypeByOid').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectStudentTypeByOid", json["oid"]);
});

//更加父id查询分类
router.route('/selectTypeByPid').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectTypeByPid", json['pid']);
});
//点击工具计数
router.route('/insertToolsCount').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "insertToolsCount", json['cid'], json['chid'], json['uid'], json['tid'], json['count']);
});
//修改工具次数
router.route('/updateToolsCount').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "updateToolsCount", json['cid'], json['chid'], json['uid'], json['tid'], json['count']);
});
//查询工具次数
router.route('/selectToolsCount').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectToolsCount", json['cid'], json['chid'], json['uid']);
});
//导出学生
router.route('/selectUserBySchool').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectUserBySchool", json['oid']);
});
//上传学生作业
router.route('/insertSWork').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "insertSWork", json['uid'], json['cid'], json['p'], json['t'], json['upload']);
});
//查询学生作业
router.route('/selectSWork').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectSWork", json['uid'], json['cid'], json['p'], json['type']);
});
//课程进展数据
router.route('/selectCase').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectCase", json['org']);
});
//课程进展数据
router.route('/selectCase2').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectCase2", json['org']);
});
//课程进展数据
router.route('/selectCase3').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectCase3", json['org'], json['oid'], json['page'], json['pageSize']);
});
//项目进展数据
router.route('/selectCaseS').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectCaseS", json['org'], json['oid']);
});

//项目进展数据
router.route('/selectCaseS2').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectCaseS2", json['org'], json['oid'], json['type'], json['page'], json['pageSize']);
});


//查询赛事项目列表
router.route('/selectRaceList').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectRaceList", json['uid']);
});
//修改赛事状态
router.route('/updateRaceState').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "updateRaceState", json['id'], json['s']);
});
//查询赛事项目详情
router.route('/selectRaceDetail').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectRaceDetail", json['id']);
});
//race 查询学校
router.route('/getSchool').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "getSchool", json['n']);
});

//lsc
//admin 查询学校
router.route('/getSchoolAdmin').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_school", json['page'], 10);
});
//admin 添加学校
router.route('/addSchoolAdmin').all((req, res, next) => {
    postmysql(req, res, "add_school");
});
//组织添加学校
router.route('/addSchoolOrg').all((req, res, next) => {
    postmysql(req, res, "addSchoolOrg");
});
//教师端组织添加学校
router.route('/insertSchoolByOrg').all((req, res, next) => {
    postmysql(req, res, "insertSchoolByOrg");
});
//admin 删除学校
router.route('/deleteSchoolAdmin').all((req, res, next) => {
    postmysql(req, res, "delete_school");
});
//admin 查询班级
router.route('/getClassAdmin').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_classAdmin", json['cn'], json['page'], 10);
});
//admin 添加班级
router.route('/addClassAdmin').all((req, res, next) => {
    postmysql(req, res, "add_classAdmin");
});
//admin 查询班级是否重复
router.route('/getClassRepeat').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_classRepeatAdmin", json['n'], json['oid']);
});
//admin 发布通知
router.route('/addNews').all((req, res, next) => {
    postmysql(req, res, "add_news");
});
//admin 删除通知
router.route('/deleteNews').all((req, res, next) => {
    postmysql(req, res, "delete_news");
});
//admin 添加banner
router.route('/addBanner').all((req, res, next) => {
    postmysql(req, res, "add_banner");
});
//admin 添加banner
router.route('/deleteBanner').all((req, res, next) => {
    postmysql(req, res, "delete_banner");
});
//admin 查询banner
router.route('/getBanner').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_banner");
});
//根据学校查询banner
router.route('/selectBannerByOid').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectBannerByOid", json["oid"]);
});
//admin 查询banner
router.route('/getBannerS').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "getBannerS");
});
//根据学校查询banner
router.route('/selectBannerByOidS').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectBannerByOidS", json["oid"]);
});
//admin 查询课程getSearchCourse
router.route('/getSearchCourse').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectAll_courseSearch", json['t']);
});
//根据学校查询课程
router.route('/getSearchCourseByoid').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectAll_courseByOid", json['t'], json['oid']);
});

//admin 查询所有课程专区
router.route('/getZone').all((req, res, next) => {
    getmysql(req, res, "select_zone");
});
//admin 添加课程专区
router.route('/addZone').all((req, res, next) => {
    postmysql(req, res, "insert_classZone");
});
//评审
router.route('/reviewCourse').all((req, res, next) => {
    postmysql(req, res, "reviewCourse");
});
//查询评审
router.route('/getReview').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "getReview", json['cid']);
});
//查询所有课程专区下的课程
router.route('/getZoneClass').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_zoneClass", json['bid'], json['oid'], json['page'], 10);
});
//查询所有课程专区下的课程
router.route('/getZoneClass').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_zoneClass", json['bid'], json['oid'], json['page'], 10);
});
//查询所有课程专区下的课程
router.route('/getZoneClassStudent').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_zoneClass", json['bid'], json['oid'], json['page'], 20);
});
//admin 后台查看专区下课程的数量
router.route('/getZoneClassNum').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_zoneClassNum", json['bid']);
});
//admin 后台添加课程专区时查看课程是否在此专区重复
router.route('/getZoneClassRepeat').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_zoneClassRepeat", json['pid'], json['cid']);
});
//把课程添加进专区
router.route('/addZoneCourse').all((req, res, next) => {
    postmysql(req, res, "insert_app");
});
//admin 删除课程专区底下的课程
router.route('/deleteZoneCourse').all((req, res, next) => {
    postmysql(req, res, "delete_app");
});
//admin 删除班级
router.route('/deleteZone').all((req, res, next) => {
    postmysql(req, res, "delete_zone");
});

//admin 后台专区上移下移
router.route('/zoneRank').all((req, res, next) => {
    postmysql(req, res, "update_classRank");
});

//admin 添加模板文档
router.route('/addTemplateAdmin').all((req, res, next) => {
    postmysql(req, res, "add_template");
});

//admin 添加模板文档
router.route('/deleteTemplateAdmin').all((req, res, next) => {
    postmysql(req, res, "delete_template");
});

//admin 查询模板文档
router.route('/getTemplateAdmin').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_template", json['page'], 10);
});

//查询上传作业
router.route('/getCourseWorks').all((req, res, next) => {
    var json = queryString(req.url); //cid 课程id,page 页数
    getmysql(req, res, "select_courseWorks", json['cid'], json['stage'], json['task'], json['page'], 10);
});
//查询上传作业
router.route('/getCourseWorks2').all((req, res, next) => {
    var json = queryString(req.url); //cid 课程id,page 页数
    getmysql(req, res, "select_courseWorks2", json['cid'], json['uname'], json['stage'], json['task'], json['page'], 10);
});

//查询上传作业
router.route('/getCourseWorks3').all((req, res, next) => {
    var json = queryString(req.url); //cid 课程id,page 页数
    getmysql(req, res, "select_courseWorks3", json['cid'], json['uname'], json['stage'], json['task'], json['page'], 10);
});

//查询所有学生上传作业
router.route('/getCourseWorks4').all((req, res, next) => {
    var json = queryString(req.url); //cid 课程id,page 页数
    getmysql(req, res, "select_courseWorks4", json['cid'], json['uname'], json['stage'], json['task']);
});

//查询学生课程作业
router.route('/selectStudentCourseWorks').all((req, res, next) => {
    var json = queryString(req.url); //cid 课程id,page 页数
    getmysql(req, res, "selectStudentCourseWorks", json['uid'], json['cid'], json['stage'], json['task'], json['page'], 10);
});
//查询报告数据
router.route('/getCourseWorksReport').all((req, res, next) => {
    var json = queryString(req.url); //cid 课程id,page 页数
    getmysql(req, res, "getCourseWorksReport", json['cid']);
});
//查询学生课程报告数据
router.route('/getStudentCourseWorksReport').all((req, res, next) => {
    var json = queryString(req.url); //cid 课程id,page 页数
    getmysql(req, res, "getStudentCourseWorksReport", json['uid']);
});
//admin 添加项目模板文档
router.route('/addCourseTemplateAdmin').all((req, res, next) => {
    postmysql(req, res, "add_courseTemplate");
});

//admin 添加项目模板文档
router.route('/deleteCourseTemplateAdmin').all((req, res, next) => {
    postmysql(req, res, "delete_courseTemplate");
});

//admin 查询项目模板文档
router.route('/getCourseTemplateAdmin').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_courseTemplate", json['page'], 10);
});

//teacher 查询项目模板
router.route('/getCourseTemplateT').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_courseTemplateT");
});
//teacher 查询项目模板
router.route('/getCourseTemplateTs').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "getCourseTemplateTs", json['oid']);
});

//admin 查询课程
router.route('/getCourseAdmin').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_courseAdmin", json['cn'], json['page'], 10);
});

//admin 查询模板文档
router.route('/deleteCourseAdmin').all((req, res, next) => {
    postmysql(req, res, "delete_courseAdmin");
});

//加入分组
router.route('/joinGroup').all((req, res, next) => {
    postmysql(req, res, "joinGroup");
});
//退出分组
router.route('/exitGroup').all((req, res, next) => {
    postmysql(req, res, "exitGroup");
});
//查看分组
router.route('/selectGroup').all((req, res, next) => {
    postmysql(req, res, "selectGroup");
});

//查询ppt在哪页
router.route('/selectPptPage').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectPptPage", json['id']);
});
//修改ppt页码
router.route('/updatePptPage').all((req, res, next) => {
    postmysql(req, res, "updatePptPage");
});
//修改ppt操作
router.route('/updatePPTHandle').all((req, res, next) => {
    postmysql(req, res, "updatePPTHandle");
});
//查询实时课堂
router.route('/getRealTimeClass').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "getRealTimeClass", json["cn"], json["uid"], json["page"], 10);
});
//查询实时课堂学生
router.route('/getRealTimeClassStu').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "getRealTimeClassStu", json["oid"], json["cid"], json["page"], 10);
});
//查询实时课堂学生
router.route('/getRealTimeClassById').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "getRealTimeClassById", json["id"]);
});

//根据区级管理者查询案例
router.route('/selectAnliList').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectAnliList", json["typea"], json["typeb"], json["typec"], json["typed"], json["typeE"], json["cn"], json["cid"], json["page"], 10);
});
//根据市级管理者查询案例
router.route('/selectAnliList1').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectAnliList1", json["typea"], json["typeb"], json["typec"], json["typed"], json["typeE"], json["cn"], json["cid"], json["page"], 10);
});
//根据省级级管理者查询案例
router.route('/selectAnliList2').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectAnliList2", json["typea"], json["typeb"], json["typec"], json["typed"], json["typeE"], json["cn"], json["cid"], json["page"], 10);
});
//删除案例
router.route('/deleteAnli').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "deleteAnli", json["id"]);
});
//根据区县管理者查询评分
router.route('/selectPoint').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectPoint", json["typea"], json["typeb"], json["typec"], json["typed"], json["typeE"], json["cn"], json["cid"], json["page"], 10);
});
//根据市级管理者查询评分
router.route('/selectPoint1').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectPoint1", json["typea"], json["typeb"], json["typec"], json["typed"], json["typeE"], json["cn"], json["cid"], json["page"], 10);
});
//查询分配案例
router.route('/selectCaseUser').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_case", json["uid"]);
});

//根据用户id，课程id，阶段，任务，工具去查询协同
router.route('/selectWord').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectWord", json["uid"], json["cid"], json["s"], json["task"], json["t"]);
});
//根据用户id，课程id，阶段，任务，工具去查询协同
router.route('/selectWord2').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectWord2", json["uid"], json["cid"], json["s"], json["task"], json["t"], json["type"]);
});
//根据用户id，课程id，阶段，任务，工具去查询协同
router.route('/selectWords').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectWords", json["uid"], json["cid"], json["s"], json["task"], json["t"], json["type"]);
});
//根据用户id，课程id，阶段，任务，工具去查询协同
router.route('/selectWordsY').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectWordsY", json["uid"], json["cid"], json["s"], json["task"], json["t"], json["type"]);
});

//新增协同内容
router.route('/insertWord2y').all((req, res, next) => {
    var json = queryString(req.url);
    // getmysql(req, res, "insertWord2y", json["uid"], json["cid"], json["s"], json["task"], json["t"], json["text"], json["type"]);
    postmysql3(req, res, "insertWord2y");
});
//新增协同内容
router.route('/insertWord').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "insertWord", json["uid"], json["cid"], json["s"], json["task"], json["t"], json["text"]);
});
//分配案例
router.route('/insertCase').all((req, res, next) => {
    if (req.body[0]) {
        p = [req.body[0].uid, req.body[0].box];
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], "insertCase"); //執行存儲過程
        mysql.usselect(p, function(ret) {
            res.end(JSON.stringify({ success: 1 }));
        });
    }
});
//新增评分 
router.route('/addScore').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "addScore", json["rid"], json["suser"], json["s"]);
});
//查询评分
router.route('/selectScore').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectScore", json["rid"]);
});
//赛事推荐
router.route('/updateRaceRec').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "updateRaceRec", json["id"], json["rec"]);
});





//teacher 查询模板
router.route('/getTemplateT').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_templateT");
});

//思维网格 创建房间
router.route('/insertRoom').all((req, res, next) => {
    postmysql(req, res, "insertRoom");
});
//删除作业阶段任务工具
router.route('/deleteStudentToolSTT').all((req, res, next) => {
    postmysql(req, res, "deleteStudentToolSTT");
});
//删除作业阶段任务
router.route('/deleteStudentToolST').all((req, res, next) => {
    postmysql(req, res, "deleteStudentToolST");
});
//删除作业阶段
router.route('/deleteStudentToolS').all((req, res, next) => {
    postmysql(req, res, "deleteStudentToolST");
});
//协同编辑 创建房间
router.route('/insertRoomByFile').all((req, res, next) => {
    //var json = queryString(req.url);
    postmysql2(req, res, "insertRoomByFile");
    //getmysql(req, res, "insertRoomByFile", json["uid"], json["n"], json["d"]);
});

//思维网格 查询是否是重复房间号
router.route('/checkRoomNum').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "checkRoomNum", json['num']);
});

//思维网格 查询房间列表
router.route('/selectRoomList').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectRoomList", json['uid'], json['oid'], json['cid'], json['cu'], json['cn']);
});

//查询pdf列表
router.route('/selectRTC').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectRTC", json['uid'], json['cu'], json['cn']);
});


//协同文档 查询房间列表
router.route('/selectFileList').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectFileList", json['uid'], json['oid'], json['cid'], json['cu'], json['cn']);
});

//协同编辑 查询是否是重复房间号
router.route('/checkRoomNumByFile').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "checkRoomNumByFile", json['num']);
});

//思维网格 根据房间号或者用户id查询房间信息
router.route('/selectRoom').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectRoom", json['uid']);
});
//思维网格 根据房间号或者用户id查询房间信息
router.route('/getRoom').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_room", json['fid']);
});

//协同编辑 根据房间号或者用户id查询房间信息
router.route('/selectRoomByFile').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "selectRoomByFile", json['uid']);
});

//思维网格 修改房间数据
router.route('/updateRoomData').all((req, res, next) => {
    postmysql(req, res, "updateRoomData");
});

router.route('/updateFileData').all((req, res, next) => {
    var json = queryString(req.url);
    var json2 = json['mode'].split(',');
    getmysql(req, res, "updateFileData", json2[0], json2[1]);
});

router.route('/select_file').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "select_file", json['fid']);
});

//思维网格 解散房间
router.route('/dismiss').all((req, res, next) => {
    postmysql(req, res, "update_room");
});

//提交提问
router.route('/addProblem').all((req, res, next) => {
    postmysql(req, res, "add_problem");
    //cid 课程id,chid 章节id,t 提问内容,uid 用户id 
});


//查询提交的提问
router.route('/getProblem').all((req, res, next) => {
    var json = queryString(req.url); //cid 课程id,page 页数
    getmysql(req, res, "select_problem", json['cid'], json['page'], 10);
});

//获取用户基本信息
router.route('/getUserInfo').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "getUserInfo", json['uid'], json['cid']);
});
//获取项目基本信息
router.route('/getCourseInfo').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "getCourseInfo", json['cid']);
});

//获取用户基本信息
router.route('/getAllUserById').all((req, res, next) => {
    var json = queryString(req.url);
    getmysql(req, res, "getAllUserById", json['uid']);
});

//作业生成报告
router.route('/getWorkData').all((req, res, next) => {
    var json = queryString(req.url); //cid 课程id,page 页数
    getmysql(req, res, "select_work_data", json['cid']);
});

//查询评价体系
router.route('/getEvaluation').all((req, res, next) => {
    var json = queryString(req.url); //cid 课程id,page 页数
    getmysql(req, res, "select_evaluation", json['oid'], json['n'], json['page'], 10);
});

//添加评价体系
router.route('/addEvaluation').all((req, res, next) => {
    postmysql(req, res, "add_evaluation");
    //uid 用户id t标题 c内容
});

//修改评价体系
router.route('/updateEvaluation').all((req, res, next) => {
    postmysql(req, res, "update_evaluation");
    //c内容 t标题 id评价id
});

//删除评价体系
router.route('/deleteEvaluation').all((req, res, next) => {
    postmysql(req, res, "delete_evaluation");
    // id评价id
});
//批量添加学校
router.route('/batchRegistrationSchool').post(function(req, res, next) {
    let users = req.body[0];
    let arr = JSON.parse(req.body[0].arr);
    for (let i = 0; i < arr.length; i++) {
        let _school = arr[i].school;
        let _org = users.org;
        //用戶數據
        let _data = [
            _school,
            _org,
            '',
            '1',
            '',
        ];
        //參數拼接，註冊
        _data.unshift(_mysqlLabor[0], _mysqlLabor[1], "insertSchoolByOrg");
        //用戶註冊處理
        mysql.usselect(_data, function(ret) {
            res.end(JSON.stringify({ success: 1 }));
        });
    }
});
//批量添加学生
router.route('/batchRegistrationMore').post(function(req, res, next) {
    let users = req.body[0];
    let arr = JSON.parse(req.body[0].arr);
    for (let i = 0; i < arr.length; i++) {
        let _username = arr[i].name;
        let _mail = arr[i].mail;
        let _password = users.password || "123456";
        let _alias = arr[i].name;
        let _oid = users.oid;
        let _ph = arr[i].phone ? arr[i].phone : '';
        let _class = arr[i].class;
        let _sId = arr[i].sId;
        //加密密碼
        _password = bcrypt.hashSync(_password, bcrypt.genSaltSync(10));
        //生成激活碼
        let _hashstr = new Date().getTime() + "";
        let _digest = crypto.createHash('sha256').update(_hashstr, 'utf8').digest('hex');
        //用戶數據
        let _userdata = [
            _mail,
            _password,
            _alias,
            "",
            1, //0老师 1学生
            _username,
            "",
            generateAPIKey(_username),
            _digest,
            "",
            _username,
            _sId,
            2, //1老师 2学生
            _oid,
            _ph,
            _class,
            '',
            "0",
        ];
        //參數拼接，註冊
        _userdata.unshift(_mysqluser[0], _mysqluser[1], "pbl_add_batchregister");
        //用戶註冊處理
        mysql.usselect(_userdata, function(ret) {
            // let _pbluserdata = [
            //     ret[1][0].uid,
            //     _username,
            //     _sId,
            //     2,
            //     _oid,
            //     _ph,
            //     _class,
            //     '',
            //     "0",
            // ];
            // _pbluserdata.unshift(_mysqlLabor[0], _mysqlLabor[1], "updateUserByEdu");
            // mysql.usselect(_pbluserdata, function(ret) {
            res.end(JSON.stringify({ success: 1 }));
            // });
        });
    }
});
//初始化密码
router.route('/iniPassword').post(function(req, res, next) {
    let users = req.body[0];
    _password = users.pa;
    //加密密碼
    _password = bcrypt.hashSync(_password, bcrypt.genSaltSync(10));
    //用戶數據
    let _userList = [
        users.uid,
        _password,
    ];
    _userList.unshift(_mysqlLabor[0], _mysqlLabor[1], "iniPassword");
    mysql.usselect(_userList, function(ret) {
        res.end(JSON.stringify({ success: 1 }));
    });
});
//批量添加教师
router.route('/batchRegistrationMore1').post(function(req, res, next) {
    let users = req.body[0];
    let arr = JSON.parse(req.body[0].arr);
    for (let i = 0; i < arr.length; i++) {
        let _username = arr[i].name;
        let _mail = arr[i].mail;
        let _password = users.password || "123456";
        let _alias = arr[i].name;
        let _org = users.org;
        let _oid = arr[i].school;
        let _ph = arr[i].phone ? arr[i].phone : '';
        let _class = arr[i].class;
        let _sId = arr[i].sId;
        //加密密碼
        _password = bcrypt.hashSync(_password, bcrypt.genSaltSync(10));
        //生成激活碼
        let _hashstr = new Date().getTime() + "";
        let _digest = crypto.createHash('sha256').update(_hashstr, 'utf8').digest('hex');
        //用戶數據
        let _userdata = [
            _mail,
            _password,
            _alias,
            "",
            0, //0老师 1学生
            _username,
            "",
            generateAPIKey(_username),
            _digest,
            "",
            _username,
            _sId,
            1, //1老师 2学生
            _org,
            _oid,
            '',
            '',
            '',
            "0",
        ];
        //參數拼接，註冊
        _userdata.unshift(_mysqluser[0], _mysqluser[1], "pbl_add_batchregister_oid");
        //用戶註冊處理
        mysql.usselect(_userdata, function(ret) {
            res.end(JSON.stringify({ success: 1 }));
        });
    }
});
//赛事批量注册老师
router.route('/pbl_add_raceuser_oid').post(function(req, res, next) {
    let users = req.body[0];
    let arr = JSON.parse(req.body[0].arr);
    for (let i = 0; i < arr.length; i++) {
        let _username = arr[i].name;
        let _mail = arr[i].mail;
        let _password = users.password || "123456";
        let _oid = arr[i].school;
        //加密密碼
        _password = bcrypt.hashSync(_password, bcrypt.genSaltSync(10));
        //生成激活碼
        let _hashstr = new Date().getTime() + "";
        let _digest = crypto.createHash('sha256').update(_hashstr, 'utf8').digest('hex');
        //用戶數據
        let _userdata = [
            _mail,
            _oid,
            _password,
            _username,
            1, //1普通教师 2市级 3省级 4市级子级评委 5县区评委 6县区子级
        ];
        //參數拼接，註冊
        _userdata.unshift(_mysqlLabor[0], _mysqlLabor[1], "pbl_add_raceuser_oid");
        //用戶註冊處理
        mysql.usselect(_userdata, function(ret) {
            res.end(JSON.stringify({ success: 1 }));
        });
    }
});
//新增学生
router.route('/batchRegistration').post(function(req, res, next) {
    var users = req.body[0];
    //循环注册
    var _username = users.alias;
    var _mail = users.username;
    var _password = users.password || "123456";
    var _alias = users.alias;
    var _oid = users.oid;
    var _ph = users.ph;
    var _class = users.cid;
    var _sId = users.sid;
    //加密密碼
    _password = bcrypt.hashSync(_password, bcrypt.genSaltSync(10));
    //生成激活碼
    let _hashstr = new Date().getTime() + "";
    let _digest = crypto.createHash('sha256').update(_hashstr, 'utf8').digest('hex');
    //用戶數據
    var _userdata = [
        _mail,
        _password,
        _alias,
        "",
        1,
        _username,
        "",
        generateAPIKey(_username),
        _digest,
        "",
        _username,
        _sId,
        2,
        _oid,
        _ph,
        _class,
        '',
        "0",
    ];
    //參數拼接，註冊
    _userdata.unshift(_mysqluser[0], _mysqluser[1], "pbl_add_batchregister");
    //用戶註冊處理
    mysql.usselect(_userdata, function(ret) {
        res.end(JSON.stringify({ uid: ret[1][0].uid, ph: _ph, oid: _oid, cid: _class, success: 1 }));
    });
});

//新增教师
router.route('/batchRegistration1').post(function(req, res, next) {
    var users = req.body[0];
    //循环注册
    var _username = users.alias;
    var _mail = users.username;
    var _password = users.password || "123456";
    var _alias = users.alias;
    var _org = users.org;
    var _oid = users.oid;
    var _ph = users.ph;
    var _class = users.cid;
    var _sId = users.sid;
    //加密密碼
    _password = bcrypt.hashSync(_password, bcrypt.genSaltSync(10));
    //生成激活碼
    let _hashstr = new Date().getTime() + "";
    let _digest = crypto.createHash('sha256').update(_hashstr, 'utf8').digest('hex');
    //用戶數據
    var _userdata = [
        _mail,
        _password,
        _alias,
        "",
        0,
        _username,
        "",
        generateAPIKey(_username),
        _digest,
        "",
        _username,
        _sId,
        1,
        _org,
        _oid,
        _ph,
        _class,
        '',
        "0",
    ];
    //參數拼接，註冊
    _userdata.unshift(_mysqluser[0], _mysqluser[1], "pbl_add_batchregister1");
    //用戶註冊處理
    mysql.usselect(_userdata, function(ret) {
        res.end(JSON.stringify({ uid: ret[1][0].uid, ph: _ph, oid: _oid, cid: _class, success: 1 }));
    });
});

router.route('/batchRegistrationOrg').post(function(req, res, next) {
    var users = req.body[0];
    //循环注册
    var _username = users.alias;
    var _mail = users.username;
    var _password = users.password || "123456";
    var _alias = users.alias;
    var _oid = users.oid;
    var _ph = users.ph;
    var _class = users.cid;
    var _sId = users.sid;
    var _org = users.org;
    //加密密碼
    _password = bcrypt.hashSync(_password, bcrypt.genSaltSync(10));
    //生成激活碼
    let _hashstr = new Date().getTime() + "";
    let _digest = crypto.createHash('sha256').update(_hashstr, 'utf8').digest('hex');
    //用戶數據
    var _userdata = [
        _mail,
        _password,
        _alias,
        "",
        1,
        _username,
        "",
        generateAPIKey(_username),
        _digest,
        "",
        _username,
        _sId,
        2,
        _oid,
        _ph,
        _class,
        '',
        "0",
        _org
    ];
    //參數拼接，註冊
    _userdata.unshift(_mysqluser[0], _mysqluser[1], "pbl_add_batchregister_org");
    //用戶註冊處理
    mysql.usselect(_userdata, function(ret) {
        res.end(JSON.stringify({ uid: ret[1][0].uid, ph: _ph, oid: _oid, cid: _class, success: 1 }));
    });
});

router.route('/batchRegistrationMoreOrg').post(function(req, res, next) {
    let users = req.body[0];
    let arr = JSON.parse(req.body[0].arr);
    for (let i = 0; i < arr.length; i++) {
        let _username = arr[i].name;
        let _mail = arr[i].mail;
        let _password = users.password || "123456";
        let _alias = arr[i].name;
        let _oid = users.oid;
        let _ph = arr[i].phone ? arr[i].phone : '';
        let _class = arr[i].class;
        let _sId = arr[i].sId;
        let _org = users.org;
        //加密密碼
        _password = bcrypt.hashSync(_password, bcrypt.genSaltSync(10));
        //生成激活碼
        let _hashstr = new Date().getTime() + "";
        let _digest = crypto.createHash('sha256').update(_hashstr, 'utf8').digest('hex');
        //用戶數據
        let _userdata = [
            _mail,
            _password,
            _alias,
            "",
            1, //0老师 1学生
            _username,
            "",
            generateAPIKey(_username),
            _digest,
            "",
            _username,
            _sId,
            2, //1老师 2学生
            _oid,
            _ph,
            _class,
            '',
            "0",
            _org
        ];
        //參數拼接，註冊
        _userdata.unshift(_mysqluser[0], _mysqluser[1], "pbl_add_batchregister_org2");
        //用戶註冊處理
        mysql.usselect(_userdata, function(ret) {
            res.end(JSON.stringify({ success: 1 }));
        });
    }
});

function generateAPIKey(username) {

    let timeStamp = new Date().getTime();

    let hashStr = timeStamp + username;

    let digest = crypto.createHash('sha256').update(hashStr, 'utf8').digest('hex');

    return digest;

}



queryString = function(url) {
    var a = url.split("?");
    var json = querystring.parse(a[1])
    return json;
}

//post存儲過程處理
postmysql = function(req, res, functionname) {
    //mode的處理
    if (req.body[0]) {
        p = Object.values(req.body[0]);
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], functionname);
        //執行存儲過程
        mysql.usselect(p, function(ret) { res.end(JSON.stringify(ret)); });
    }
}

//post存儲過程處理
postmysql2 = function(req, res, functionname) {
    //mode的處理
    if (req.body) {
        p = Object.values(req.body)[0].split(",");
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], functionname);
        //執行存儲過程
        mysql.usselect(p, function(ret) { res.end(JSON.stringify(ret)); });
    }
}

//post存儲過程處理
postmysql3 = function(req, res, functionname) {
    //mode的處理
    if (req.body) {
        p = Object.values(req.body);
        p.unshift(_mysqlLabor[0], _mysqlLabor[1], functionname);
        //執行存儲過程
        mysql.usselect(p, function(ret) { res.end(JSON.stringify(ret)); });
    }
}

//get獲取數據庫信息
getmysql = function(req, res, functionname, ...p) {
    p = p || [];
    p.unshift(_mysqlLabor[0], _mysqlLabor[1], functionname);
    //執行存儲過程
    mysql.usselect(p, function(ret) { res.end(JSON.stringify(ret)); }); //
}


//post存储过程处理

userpostmysql = function(req, res, functionname) {

    //mode的处理

    if (req.body.mode) {

        p = req.body.mode.split(",");

        p.unshift(_mysqluser[0], _mysqluser[1], functionname);

        //执行存储过程

        mysql.usselect(p, function(ret) { res.end(JSON.stringify(ret)); });

    }

}



//get获取数据库信息

usergetmysql = function(req, res, functionname, ...p) {

    p = p || [];

    p.unshift(_mysqluser[0], _mysqluser[1], functionname);

    //执行存储过程

    mysql.usselect(p, function(ret) { res.end(JSON.stringify(ret)); }); //

}

module.exports = router;